// gp.cc   File for common problem code, build with GPQUICK-2.1
// W. Langdon cs.ucl.ac.uk 23 January 1995
//                     based upon queue2.cc 20 Dec 1994 Revision: 1.57
#define main_version "$Revision: 1.72 $"

//Modifications (in reverse order)

//WBL 31 Dec 96  If pTraceDupStats or pTracePStats or pTraceDStats
//               report every generation even if more than 50 

//WBL 19 Dec 96  Add calling DisplayDupStats()

//WBL 13 Apr 96  Use cout rather than sprint format best, works with float!

//WBL  8 Apr 96  Add pSeeds

//WBL 10 Dec 95  Undo r1.53 (remove ThisTest->write_stats() from do_gens

//WBL 10 Dec 95  Quick and dirty fix for int scoretype after find_elite
//WBL 20 Oct 95  BUG Notice save/restore does not use original test_seed
//WBL 18 Oct 95  Support test_seed

//WBL 10 Oct 95  Remove PRETTY_PARENS
//               Restore display of best every gen

//WBL 22 Sep 95  Replace list.h by prob.h

//WBL 29 Aug 95  mangle "calls" so can see fix to pareto.cc is in

//WBL  6 Aug 95  Add saving of test.cc and list.cc globals in dumpfile

//WBL 30 Jun 95  Add save_state and restart

//WBL 20 Jun 95  Add calling gethostname

//WBL  7 May 95  Add calling DisplayLPStats

//WBL  1 May 95  Add support for DisplayPStats
//               Ensure no more than 50 intermediate reports are generated

//WBL 19 Apr 95  Increase outputsize from 1000
//                 in display_best_stats to 5000
//                 in display_ellite and display_all_best to popsize

//WBL  7 Apr 95  Add clearing pElitist before Load()

//WBL 23 Mar 95  Add clearing pElitist before delete pop
//               Call either display_all_best or display_elite

//WBL 12 Mar 95  Replace calling display_all_best by display_elite

//WBL 12 Mar 95  In do_gens call new function display_best_stats inplace of
//               display_all_best. Do stats every gen rather than evry 5th

//WBL 26 Feb 95  Use ThisPop

//WBL 25 Feb 95  Bump output display_size of pareto front from 50 to 1000
//               hopefully temporaily!
//               Display stats etc only every 5 gens rather than every one

//WBL 19 Feb 95  Replace all uses of BestMember by display_all_best
//               Add calling select_hits_write_stats

//WBL 18 Feb 95  Add reporting number of duplicate chromes along pareto front

//WBL 11 Feb 95  Get fitness() working

//WBL 23 Jan 95  New file


//requires MULTREE to be defined

#include <sys/param.h>
#include <unistd.h>
//#include <procbuf.h> //located at /bham/pd/packages/gcc/lib/g++-include/
#include <assert.h>
#include "pch.h"
#include "chrome.h"
#include "primitiv.h"

//pickup problem library
#include "prob.h"

//#include "Primitives.h"
#include "gp.h"
#include "test.h"

//extern char scratch[100];
#ifdef FASTEVAL
//	extern evalnode* IpGlobal;
//	extern Chrome* ChromeGlobal;
#endif


gp* ThisProblem;
extern test* ThisTest;
test* ThisTest;
ChromeParams* ThisParams = new ChromeParams();
float max_fitness = 0;
Pop* ThisPop;
//**************************************************************************
///////////////////////// PROBLEM definition

void output_header(ostream& fout)
{	time_t start;

	fout << "\nGP ("<<main_version << flush;
	fout << ") to evolve a "<<ThisProblem->ProbVersion<<endl;
	time (&start);
	fout << ctime(&start) << flush;
#ifdef MAXHOSTNAMELEN
	{char buffer[MAXHOSTNAMELEN];
	 fout << "Node " << flush;
	 gethostname(buffer,sizeof(buffer));
	 fout << buffer << endl;
        }
#else
	 fout << "Node ?"<< endl;
#endif
}//end output_header

void output_globals(ostream& fout)
{
	fout<<current_phase<<endl;
	fout<<total_cpu<<endl;
	fout<<tests_run<<endl;
	fout<<tests_apparently_run<<endl;
	fout<<num_sol_found<<endl;
}//end output globals

void delete_dumpfile(char* type)
{
char dumpfile[2*(ChromeParams::param_str_size)+12];

strcpy(dumpfile,ThisParams->params_str[pDumpfile1]);
strcat(dumpfile,ThisParams->params_str[pDumpfile2]);
strcat(dumpfile,type); //nb the other file

ofstream fout(dumpfile); //Unix specific
if(!fout)
	cerr <<"Failed to delete dumpfile "<<dumpfile<< flush;

fout.close(); //well its of zero length, good enough
}//end delete_dumpfile


int save_state_count = 1;
time_t last_save_time;

void save_state(int phase_number) 
{
time_t time_;
time (&time_);

if( ( (strlen(ThisParams->params_str[pDumpfile1])+
       strlen(ThisParams->params_str[pDumpfile2]) )!=0) &&
    ( ((time_ - last_save_time) > 3600          )||	//save once per hour
//    ( ((time_ - last_save_time) > 0          )||	//save once per sec
      (phase_number != 0                        )     )    ) { 

	char dumpfile[3*(ChromeParams::param_str_size)+12];

        strcpy(dumpfile,ThisParams->params_str[pZipCmd]);
        strcat(dumpfile,ThisParams->params_str[pDumpfile1]);
        strcat(dumpfile,ThisParams->params_str[pDumpfile2]);
	if(phase_number != 0 ) {
		char buff [12];
		sprintf(buff,".%d",phase_number);
		strcat(dumpfile,buff);
	}
	else if((++save_state_count&1) == 0)
		strcat(dumpfile,".A");
	else
		strcat(dumpfile,".B");

	BOOL ok = FALSE;

#ifdef PROCBUF
	if(strlen(ThisParams->params_str[pZipCmd]) != 0) {
		procbuf popen_(dumpfile,ios::out);
		ostream fout( &popen_ );
		if(!fout)
			cerr <<"Failed to open dumpfile "<<dumpfile
				<<" "<< ctime(&time_) << flush;
		else {
			cout <<"Writing dumpfile "<<dumpfile
				<<" "<< ctime(&time_) << flush;
			output_header(fout);
			fout<<ThisPop->gencount<<endl;
			ThisParams->params[pPopSeed] = gpquick_seed; //record seed used
//                      cout <<	"gpquick_seed "<<gpquick_seed<<endl;//debug
			ThisParams->Save(fout);
			fout<<endl; //note end of params
			output_globals(fout);
			ThisPop->Write(fout,TRUE); //binary mode

			popen_.close();
			ok = TRUE;
		}
	}
else 
#endif //PROCBUF
{
	ofstream fout(dumpfile);
	if(!fout)
		cerr <<"Failed to open dumpfile "<<dumpfile
		     <<" "<< ctime(&time_) << flush;
	else {
		cout <<"Writing dumpfile "<<dumpfile
		     <<" "<< ctime(&time_) << flush;
		output_header(fout);
		fout<<ThisPop->gencount<<endl;
		ThisParams->params[pPopSeed] = gpquick_seed; //record seed used
//cout <<	"gpquick_seed "<<gpquick_seed<<endl;//debug
		ThisParams->Save(fout);
		fout<<endl; //note end of params
		output_globals(fout);
		ThisPop->Write(fout,TRUE); //binary mode

		fout.close();
		ok = TRUE;
	}
}
	if(ok) {
		if(phase_number == 0) { //delete the other dump file 
			if((save_state_count&1) != 0)
				delete_dumpfile(".A"); //nb the other file
			else
				delete_dumpfile(".B");
		}
		else{
			delete_dumpfile(".A"); //delete both files
			delete_dumpfile(".B"); //even if they dont exist!
		}

		time (&time_);
		cout <<" done "<< ctime(&time_) << endl;
		memcpy(&last_save_time,&time_,sizeof(time_));
	}//endif fout ok
}
}//end save_state

void skip_line(istream& fin, int num_lines)
{
for(int l=0; l<num_lines;l++){
	char c;
	for(c=fin.get(); (c != '\n') && (c != EOF); c=fin.get()) cout<<c;
cout<<endl;
};
}//end skip_header


int load_save(istream& fin, int argc, char * argv[])
{
	skip_line(fin,4);
	int gencount_;
	fin>>gencount_;
	skip_line(fin,1); //discard rest of line
	ThisParams->Load(fin);
//	skip_line(fin,1);

//restore paramters given on command line
	for(int i=0; i<argc;i++) {
		ThisParams->Load(argv[i]); }

	int c = fin.peek();
	if( c == '-' || (c >= '0' && c <= '9')) {
		fin>>current_phase;
		fin>>total_cpu;
		fin>>tests_run;
		fin>>tests_apparently_run;
		fin>>num_sol_found;
		fin.get(); //discard eol
	}
	else	cout << "Test global data missing from dumpfile\n";

	if ((!fin) || (fin.peek()==EOF)) {
		cerr << "Format error on reading dumpfile\n";
		exit(0);
	}

	gpquick_seed = ThisParams->params[pPopSeed];
	int pop_size = ThisParams->params[pPopSize];
	ThisPop = new Pop(ThisProblem,ThisParams,pop_size,&fin);
	cout << "Old pop -- loaded\n";
	return gencount_;
}

int open_zipped(char* name, int argc, char * argv[])
{
	int gencount_ = -1;
#ifdef PROCBUF
	BOOL loadfile;
	char dumpfile[3*(ChromeParams::param_str_size)+15];

        strcpy(dumpfile,ThisParams->params_str[pDumpfile1]);
        strcat(dumpfile,ThisParams->params_str[pDumpfile2]);
        strcat(dumpfile,name);
	ifstream fin(dumpfile);
	loadfile = (fin && (fin.peek()!=EOF));
	fin.close();

if(loadfile){
//	cout<<dumpfile<<" ok"<<endl;

        strcpy(dumpfile,"cat ");
        strcat(dumpfile,ThisParams->params_str[pDumpfile1]);
        strcat(dumpfile,ThisParams->params_str[pDumpfile2]);
        strcat(dumpfile,name);
        strcat(dumpfile," | gunzip");
	procbuf popen_(dumpfile,ios::in);
	istream fin( &popen_ );
	if(!fin)
		cout<<"Failed to open loadfile "<<dumpfile<<endl;
	else {
		cout << "Loading old population from "<<dumpfile<<endl;
		gencount_ = load_save(fin, argc, argv);
	}
	popen_.close();
}
#else
	cout<<"gzip not supported"<<endl;
#endif
return gencount_;

}//end open_zipped


int open_dump (char* name, int argc, char * argv[])
{
	int gencount_ = -1;
	BOOL loadfile;
	char dumpfile[3*(ChromeParams::param_str_size)+15];

        strcpy(dumpfile,ThisParams->params_str[pDumpfile1]);
        strcat(dumpfile,ThisParams->params_str[pDumpfile2]);
        strcat(dumpfile,name);
	ifstream fin(dumpfile);
	loadfile = (fin && (fin.peek()!=EOF));

	if(loadfile){
		cout << "Loading old population from "<<dumpfile<<endl;
		gencount_ = load_save(fin, argc, argv);
	}
	fin.close();

return gencount_;

}//end open_dump


int load_dumpfile(int argc, char * argv[]) //if possible
{
int gencount_;


if(strlen(ThisParams->params_str[pZipCmd]) != 0) {
	gencount_ = open_zipped(".A", argc, argv );
	if (gencount_ < 0 )
		gencount_ = open_zipped(".B", argc, argv );
}
else {
	gencount_ = open_dump(".A", argc, argv );
	if (gencount_ < 0 )
		gencount_ = open_dump(".B", argc, argv );
}

return gencount_;


}//end load_dumpfile

//************************************************************
#ifdef PARETO
void display_best_stats(Pop* pop, int popsize)
{
int i, dummy;
#define outputsize_max 5000
int outputsize = outputsize_max;
int output[outputsize_max];
int duplicates[outputsize_max];

select_hits(
pop->pop, popsize, 0, &dummy, TRUE, output, duplicates, &outputsize);

cout<<"Best ("<<outputsize<<") in population "<<flush;

int sum   = 0;
int sumsq = 0;
for (i=0; i<outputsize; i++){
	sum   += duplicates[i];
	sumsq += duplicates[i] * duplicates[i];
	}

float mean     = float(sum)/float(outputsize);
float variance = (float(sumsq)/float(outputsize))-mean*mean;
float sd       = (variance>0) ? sqrt(variance) : 0.0; //protect from rounderrs
cout <<sum
     <<"\tMean = "<<mean
     <<"\tSD = "<<sd
     <<endl;
}//end display_best_stats();


void dout(int i)
{
char buf[80]; sprintf(buf,"%5d",i); cout << buf;
}

void display_list(Pop* pop, int output[], int duplicates[], int outputsize, 
		  int popwidth,	BOOL details)
{
#define max_display_list 10

cout<<"Best ("<<outputsize<<") in population "<<endl;

for (int i=0; i<outputsize; i++){
	if (popwidth == 0) dout(output[i]);
	else 
		{dout(output[i] % popwidth);
		 dout(output[i] / popwidth);}
	dout(duplicates[i]);
	pop->pop[output[i]]->nfitness->write();
	cout<<endl;
}//end loop write fitness only

for (i=0; i<outputsize && i<max_display_list; i++){
	if (popwidth == 0) dout(output[i]);
	else 
		{dout(output[i] % popwidth);
		 dout(output[i] / popwidth);}
	dout(duplicates[i]);
	pop->pop[output[i]]->nfitness->write();
#ifdef TRACE
	if ( details ) pop->pop[output[i]]->write(PRETTY_NONE,cout);
#endif
	cout<<endl;
}//end loop
}//end display_list


void display_elite(Pop* pop, int popsize, int popwidth)
{
int i;
const int limit = popsize;
//Chrome*  chromes[limit];
Chrome** chromes = new Chrome* [limit];
int num_elite;
scoretype best [num_ellite_pareto];
int       count[num_ellite_pareto];

find_elite(chromes, limit, num_elite, best, count);

cout<<"Ellite ("<<num_elite<<") in population "<<endl;

cout<<"bst ";
for (i=0; i<num_ellite_pareto; i++){
//	char buf[80]; sprintf(buf,"%4d",best[i]);
//	cout << buf << ",";
	cout << best[i] << ",";
}
cout<<endl;
cout<<"No. ";
for (i=0; i<num_ellite_pareto; i++){
	char buf[80]; sprintf(buf,"%4d",count[i]);
	cout << buf << ",";
}
cout<<endl;

//Now reduce size of list of best in pop by weeding out those dominated
//by others in the list.

int dummy;
int outputsize = num_elite;
//int duplicates[outputsize];
//int slot      [outputsize];
int* duplicates = new int [outputsize];
int* slot       = new int [outputsize];
{
//int output    [outputsize];
int* output     = new int [outputsize];

select_hits(
chromes, num_elite, 0, &dummy, TRUE, output, duplicates, &outputsize);

//Now convert output to slot numbers in pop.

for (i=0; i<outputsize; i++){
	BOOL found = FALSE;
	for(int s=0; !found; s++) {
		assert(s<popsize);
		if(pop->pop[s] == chromes[output[i]]) {
			found = TRUE;
			slot[i] = s;
		}
	}
}
delete[] output;
}//end scope output

display_list(pop, slot, duplicates, outputsize, popwidth, TRUE);

delete[] slot;
delete[] duplicates;
delete[] chromes;
}//end display_elite();

void display_all_best(Pop* pop, int popsize, int popwidth, BOOL details)
{
int dummy;
int outputsize = popsize;
//int output[outputsize];
//int duplicates[outputsize];
int* output     = new int [outputsize];
int* duplicates = new int [outputsize];

select_hits(
pop->pop, popsize, 0, &dummy, TRUE, output, duplicates, &outputsize);

display_list(pop, output, duplicates, outputsize, popwidth, details);

delete[] duplicates;
delete[] output;
}//end display_all_best();
#endif //PARETO

//void write_fitness_summary()
//{
//
//};//end write_fitness_summary


//**************************************************************************
int do_gens (Pop* pop, int number, int tree, int& phase) //return if complete or not
{    
     pop->ClearCStats();
     cout << "Running, gpquick_seed " << gpquick_seed
          << " at " <<pop->gencount+1 << ". ";
     if ( tree >= 0 )
	  {  cout << "Crossover in ";
             ThisProblem->WriteTreeName(tree);
          }
     else
	     cout << "Random crossover tree\n";
//   cout << "gpquick_seed "<<gpquick_seed<<endl;//debug

     if(pop->params->params[pTournOff] != 0         && 
	pop->params->params[pTournSize] > 1 &&
	(pop->gencount+1)>=pop->params->params[pTournOff]) {
       cout<<"Setting pTournSize to 1\n";
       pop->params->params[pTournSize] = 1;
     };

     Chrome* last_chrome = pop->go_until(0,number,max_fitness,tree);

//     if((((pop->gencount+1)/ThisParams->params[pPopSize]) <= 1)   ||
//	(((pop->gencount+1)/ThisParams->params[pPopSize])%5 == 0))   {
     // Display the best so far
     cout << "\n\nAfter " << pop->gencount+1 << " ";
#ifdef PARETO
     if(ThisParams->params[pTrace] & pTracePareto )
	     display_all_best(pop, ThisParams->params[pPopSize],
			      ThisParams->params[pPopWidth], TRUE);
     display_best_stats(pop, ThisParams->params[pPopSize]);
#else
     cout << " generates, BestFitness = ";
     cout << pop->BestFitness->fvalue << " ";

#ifdef TRACE
     cout << pop->BestMember;
     pop->pop[pop->BestMember]->write_trace();
     pop->pop[pop->BestMember]->write(PRETTY_NONE,cout);
     cout << endl;
#endif
#endif //PARETO
     pop->DisplayStats();
     if ( ThisParams->params[pTrace] & pTraceDStats ) pop->DisplayDStats();
     if ( ThisParams->params[pTrace] & pTracePStats ) pop->DisplayPStats();
     else                                             pop->DisplayLPStats();
     if ( ThisParams->params[pTrace] & pTraceDupStats)pop->DisplayDupStats();


//     display_run(pop->best()); //show what it does
//     test_all_adf1(pop, 1);
//     }
#ifdef PARETO
     cout<<"select_hits callss ";select_hits_write_stats(); cout<<endl;
#endif
     cout<<"crossovers ";pop->DisplayCStats();

     phase = end_gens(); //problem specific

#ifdef GRID_LIB
     display_schedule_counts(cout);
#endif

     return (last_chrome->nfitness->fvalue >=max_fitness);

}//end do_gens()
///////////////////////////////  MAIN

int main(int argc, char * argv[])
{
	time_t start, end;

	ThisProblem=new gp();
	output_header(cout);

	assert ( NUM_TREES >= NUM_OPERATIONS );

	time (&start);
	memcpy(&last_save_time,&start,sizeof(start));

	ifstream gpParams ("gp.ini");
	if ( gpParams )
	     { ThisParams->Load(gpParams);
	       gpParams.close();
             }
	else {
		cerr << "Could not open gp.ini\n";
		exit(0);
	     }

	ifstream gpTests ("gp.test");
	if ( gpTests )
	     { ThisTest = new test(ThisProblem, gpTests);
	       gpTests.close();
//	       ThisTest->write(ThisProblem,cout);//debug
             }
	else {
		cerr << "Could not open gp.test"<<endl;
		exit(0);
	     }

	for(int i=0; i<argc;i++) {
		ThisParams->Load(argv[i]); }

	int initial_gencount = load_dumpfile(argc, argv); //if possible
		
	ThisTest->test_seed = ThisParams->params[pTestSeed];
	if ( ThisParams->params[pPopSeed] > 0 )
		gpquick_seed = ThisParams->params[pPopSeed];  //dirty I know
	else
	      { rndomize(); //use random seed
		ThisParams->params[pPopSeed] = gpquick_seed; //record seed used
	      }

	max_fitness = setmaxfit(ThisParams);

	ifstream gpLoad ("gp.load");
	if ( gpLoad )
	     { cout << "Loading chromes from gp.load\n";
	       if(ThisParams->params[pSeeds]==0) {
	       ThisParams->params[pPopSize]=1;
	       ThisParams->params[pGenerateLimit]=1;
             }}
	else if(ThisParams->params[pSeeds]!=0)
		cout << "Failed to open gp.load\n";

	int pop_size = ThisParams->params[pPopSize];
	int gen_max  = ThisParams->params[pGenerateLimit];

	if( initial_gencount<0 ) {
	cout << "Creating new population of " << pop_size<< " individuals\n";
	if(gpLoad && ThisParams->params[pSeeds]!=0)
		ThisPop = new Pop(ThisProblem,ThisParams,pop_size,&gpLoad);
	else
	ThisPop = new Pop(ThisProblem,ThisParams,pop_size);
	cout << "new Pop -- completed\n";
        }
	else
		ThisPop->gencount = initial_gencount - (pop_size-1);

	write_problem_params();
	ThisParams->Save();

	int done;
	if ( gpLoad && ThisParams->params[pSeeds]==0 )
	     { cout << "Overwritting with file gp.load\n";
	       //prevent trying to maintain list of best members of population
	       ThisParams->params[pElitist] = 0;

	       current_phase = ThisTest->num_phases-1; //display all tests

	       int rval = ThisPop->pop[0]->Load(gpLoad, TRUE);
	       if (rval != 0)
		       cout<<"Load error - "<<rval<<endl;
	       else
		   {   ThisTest->test_seed = ThisParams->params[pTestSeed];
		       ThisPop->pop[0]->SetupEval();
		       ThisProblem->fitness(ThisPop->pop[0]);
		       ThisPop->pop[0]->write_trace();
		       ThisPop->pop[0]->write(PRETTY_NONE,cout);
#ifdef ADF_CACHE
		       cache_stats_init();
#endif
		       display_run (ThisPop->pop[0]);
#ifdef ADF
//		       test_all_adf1(ThisPop, 0);
#endif
	           }
	       gpLoad.close();
	       done = TRUE;
        }
else
{
	int phase;
	cout << "Setting each fitness value\n";
	done = do_gens (ThisPop, pop_size-1, -1, phase); //no xover on init pop

	cout << "Initial fitness values calculated,\n";
	if ( initial_gencount >= 0 ) {
//		ThisPop->gencount = initial_gencount;

		//It is important that gpquick_seed is restored to correct
		//value. This step is only required because generate()
		//unneccessarily calls rnd()
		gpquick_seed = ThisParams->params[pPopSeed];
	}

	cout << "Creating a total of " << gen_max << " individuals\n";

	const int generates_per_report = pop_size *
	  ((ThisParams->params[pTrace] & 
	    (pTraceDStats|pTracePStats|pTraceDupStats))? 
	   1 : ((gen_max+(50*pop_size)-1)/(50*pop_size)));
	if( ((ThisPop->gencount+1) % generates_per_report!=0) &&
	    ((ThisPop->gencount+1) < gen_max) && !done && !kbhit() )  
	{
		done = do_gens (ThisPop, generates_per_report-pop_size, -1,
				phase);
#ifdef PARETO
		if(ThisParams->params[pElitist] == 0)
			display_all_best(ThisPop,ThisParams->params[pPopSize], 
					 ThisParams->params[pPopWidth], TRUE);
		else
			display_elite(   ThisPop,ThisParams->params[pPopSize], 
				         ThisParams->params[pPopWidth]);
#endif
	}//endif catchup to even boundary on generates
	                         // kbhit IS NOT PORTABLE (Borland specific)
	while ( (ThisPop->gencount+1) < gen_max && !done && !kbhit() )  
	{
		done = do_gens (ThisPop, generates_per_report, -1, phase);
		save_state(phase);
#ifdef PARETO
		if(ThisParams->params[pElitist] == 0)
			display_all_best(ThisPop,ThisParams->params[pPopSize], 
					 ThisParams->params[pPopWidth], TRUE);
		else
			display_elite(   ThisPop,ThisParams->params[pPopSize], 
				         ThisParams->params[pPopWidth]);
#endif
	}
	save_state(9);


//	// Display the best
	cout << "\n\nFINAL RESULTS. After " << ThisPop->gencount+1 << " ";
#ifdef PARETO
	if(ThisParams->params[pElitist] == 0)
		display_all_best(ThisPop, ThisParams->params[pPopSize], 
				 ThisParams->params[pPopWidth], TRUE);
	else
		display_elite(   ThisPop, ThisParams->params[pPopSize], 
				 ThisParams->params[pPopWidth]);
#else
	cout << " generates, BestFitness = ";
	cout << ThisPop->BestFitness->fvalue<<endl;
#endif //PARETO

	// Display the final population
	if ( ThisParams->params[pTrace] & pTraceStatic )
	  {  cout << "\n\nFINAL Population";
	     ThisPop->Write();
          }

//	display_run(ThisPop->best()); //show what it does

}//if not loading from file

	ThisProblem->write_stats();
	ThisTest->write_stats();

	time (&end);
	cout << "\nGP took " << end - start << " secs. Finished at ";
	cout << ctime(&end);
//	cout << clock() << " ticks cpu";
	cout << endl;

        //prevent trying to maintain list of best members of population
        ThisParams->params[pElitist] = 0;

	delete ThisPop;
	delete ThisProblem;
	delete ThisParams;	
        return done? 1 : 0;
}
