############################################################################
#
#       Project		GP dyck program using indexed memory
# 			using UCL GNU/Unix/etc $Revision: 1.7 $ 
#	    
#       Author		W.Langdon
#
#	Created		6 Oct 1995, based upon brack.make Revision: 1.2
# 									   
#	Modifications:  
#
#	Module:         karp.make
#
#	Description:          
#
#	FLAGS:     	-DTWOD?
#			-DDEBUG, if debugging messages should pop up?
#
#	Notes		ensure pch.h contain #define UNIX
#			chrome.h karp.h #define MULTREE
#
############################################################################

#assumes KARP2 is not defined

NAME 	= GPkarp
OBJS 	= gp.o  brack.o  test.o stats.o  pareto.o	chrome.o   primitiv.o   Primitives.o  selector.o
LIBS 	= -lg++ -lm
CC 	= gcc
COMPILE = $(CC) -c $(CFLAGS)
CFLAGS 	= -ansi -O2 -Wall -Winline
#CFLAGS	= -ansi -O2 -Wno-import -W -Wimplicit -Wreturn-type -Wunused\
#-Wswitch -Wcomment -Wtrigraphs -Wformat -Wchar-subscripts \
#-Wuninitialized -Wparentheses -Wtemplate-debugging\
#-Winline 
#CFLAGS = -pg -O2 -fkeep-inline-functions -ansi -g -Wall
LINK 	= $(CC) -o 
LDFLAGS =  -Wall -g
#LDFLAGS = -pg -g -static


$(NAME):$(OBJS) 
	$(LINK) $(NAME) $(LDFLAGS) $(OBJS) $(LIBS)

#C++ source files

gp.o:	gp.cc pch.h chrome.h selector.h karp.h primitiv.h Primitives.h gp.h test.h
	$(COMPILE) gp.cc

brack.o:	brack.cc pch.h chrome.h selector.h karp.h primitiv.h Primitives.h gp.h test.h
	$(COMPILE) brack.cc

test.o:	test.cc pch.h chrome.h selector.h karp.h test.h Primitives.h gp.h test.run.cc test.fitness.cc
	$(COMPILE) test.cc

stats.o:	stats.cc pch.h chrome.h selector.h karp.h gp.h
	$(COMPILE) stats.cc

pareto.o:	pareto.cc pch.h chrome.h selector.h karp.h Primitives.h gp.h
	$(COMPILE) pareto.cc

chrome.o:	chrome.cxx pch.h chrome.h selector.h karp.h
	$(COMPILE) chrome.cxx

primitiv.o:	primitiv.cxx pch.h chrome.h selector.h karp.h primitiv.h
	$(COMPILE) primitiv.cxx

Primitives.o:	Primitives.cc pch.h chrome.h selector.h karp.h Primitives.h gp.h
	$(COMPILE) Primitives.cc

selector.o:	selector.cxx pch.h selector.h
	$(COMPILE) selector.cxx
