// list.cc   File to demonstrate evolution of queue, build with GPQUICK-2.1
// W. Langdon cs.ucl.ac.uk 24 Jan 1995
//                     based upon queue2.cc 24 Jan 1995 Revision: 1.??
#define list_version "list. $Revision: 1.87 $"

//#define DEBUG 

//Modifications (in reverse order)

//WBL  4 Apr 97  Easter 1997 Release. Restore r1.74 functionality (regarding
//               gp::gp(), static_check and final_score) retain bugfixes 
//               Remove update_rank (now done by InsertMember)
//               Make compatble with DEC UNIX Alpha C Compiler
//               Make compatible with MAXTREEDEPTH

//WBL 30 Aug 95  Disable syntax rules entirely

//WBL 30 Aug 95  Make syntax much less restrictive
//               Allow PROG2, forwhile, i0 in any tree (allow nested loop)
//               Allow aux1 everywhere but Next and Previous
//               Allow ARG1 and ARG2 in all _adfs where valid ie Insert_adf
//               Allow read, write, swap everywhere but end,first,next,prev
//               Allow print in Printlist
//               Allow End,First,Next,Previous to be calld by all but eachother
//               Allow Insert,Delete,Locate,Printlist to call own adf directly

//               Remove restriction on nested loops and print

//WBL  8 Aug 95  Add current_phase_reported

//WBL  8 Aug 95  BUGFIX ensure only call update_population_fitness() once

//WBL  8 Aug 95  BUGFIX replace constant NUM_TEST_PHASES by var num_phases

//WBL 27 Jun 95  Support multiple testing phases

//WBL 26 Jun 95  After 1st solution is found, remove cpu amd mem thresholds

//WBL 20 Jun 95  Add ProbLTStat

//WBL 29 May 95  Restore calling update_population_fitness once sol_found.
//               and remove fitness dependance on Memory_errors()

//WBL 28 May 95  Move write_problem_params into this file (from gp.cc)
//               add display of (new value of) cpu_penalty_bot

//WBL 27 May 95  Support op_ok

//WBL 26 May 95  BUGFIX minor chance of ChooseCrossTree not setting tree

//WBL 25 May 95  Make ChooseCrossTree part of Chrome and return its answer 

//WBL 23 May 95  Make ChooseCrossTree inactive untill pass more tests than fail

//WBL 22 May 95  Make ChooseCrossTree take into account those test which were
//               were not run (due to stop_on error)

//WBL 22 May 95  Change so max_fitness > max_passes rather than setting highest
//               fitness ever report to < max_passes. Should be cosmetic,
//               ie get printing ok

//WBL 14 May 95  BUGFIX(for 14 May) dont display gencount on initial pop

//WBL 14 May 95  BUGFIX(for 12 May) protect against cpu_time overflow

//WBL 14 May 95  Allow to run past solution. BUT DONT CHANGE FITNESS FUNCTION

//WBL 12 May 95  Add ProbLPStats

//WBL 12 May 95  Add support for memory_errors. Include them in memory fitness
//               penalty only after sol_found

//WBL 12 May 95  Report each new solution found internally, rather than
//               relying on gp.cc to report the whole population.
//               Remove perfect

//WBL 10 May 95  Allow run to continue passed 1st solution (see 9 May), 
//               passed solution with no memory or cpu penalties. Report 
//               solutions found which use less memory or less cpu. Add
//               update_population_fitness

//WBL  9 May 95  Add perfect()

//WBL  7 May 95  Remove second parent from consideration in ChooseCrossTree
//               since blurs distictions esp if cross with self-similar
//               Reduce tournament size from 7 to 3.

//WBL  7 May 95  Correct display of cache statistics.
//               Enlarge field used to print ok-nak

//WBL  3 May 95  Add STORE_FIT

//WBL  2 May 95  Add ChooseCrossTree

//WBL  2 May 95  Add TRACE_RUN

//WBL  1 May 95  Remove Ifeq (SUB works quite well!). 
//               Remove ARG1, ARG2 and next from ins_adf (reorder Adf1_xxx)

//WBL 30 Apr 95  Comment out chains

//WBL 23 Apr 95  Add Ntests_run and cpu penalty

//WBL 23 Apr 95  Add First and End caches

//WBL 22 Apr 95  Remove Iflte. Remove Aux1 from Next and Prev, xxx_adf,
//               Makenull, Retrieve, Locate and Printlist
//               Add next_cache and prev_cache

//WBL 20 Apr 95  Add IsLoop, TIMINGS

//WBL 18 Apr 95  Replace adf2 by swap

//WBL 17 Apr 95  More restrictive version of which primitives can be in which
//               tree and more checks by static_check. And more debug info

//WBL  8 Apr 95  Add insert_adf, delete_adf, locate_adf and printlist_adf

//WBL  7 Apr 95  Remove loops except from adf1 and other who calls who changes

//WBL 6  Apr 95  Replace arg1 and arg2 by ARG1 and ARG2 in insert, delete
//               and locate. Update static_check

//WBL 31 Mar 95  Add ForWhileEval and Prog2Eval etc

//WBL 23 Mar 95  Display fvalue in fixed field width

//WBL 22 Mar 95  Set chains to NULL

//WBL 14 Mar 95  Do clear inline

//WBL 11 Mar 95  Add static_tests to ensure use of arg1 and arg2

//WBL 21 Feb 95  Performance improvements. Inline update_score (nb move to
//               test.cc) Call cells_written only once.

//WBL 16 Feb 95  Fix bug in calculating amout of memory used.

//WBL 15 Feb 95  Used fixed feild width in outputing hits
//               Add update_passed

//WBL 13 Feb 95  Comment out TopEval and BotEval on the principle of
//               minimum change from queue.

//WBL 11 Feb 95  Add update_score and final_score

//WBL 24 Jan 95  New file

//requires MULTREE to be defined

#include <assert.h>
#include "pch.h"
#include "chrome.h"
#include "primitiv.h"
#include "list.h"
#ifdef TRACE_RUN
#include "trace.h"
#endif
#ifdef TIMINGS
#include "time.h"
#endif
#include "Primitives.h"
#include "gp.h"
#include "test.h"

extern char scratch[100];
#ifdef FASTEVAL
	extern evalnode* IpGlobal;
	extern Chrome* ChromeGlobal;
#endif

extern Pop*  ThisPop;
extern test* ThisTest;

const int tree_arg_num[Printlist+1] = {0,1,2,1,0,0,1,1,1,0};
const BOOL tree_return_value[Printlist+1] = 
                       {TRUE,TRUE,FALSE,FALSE,TRUE,TRUE,TRUE,TRUE,TRUE,FALSE};

int num_sol_found = 0;//used to report solution to each test phase found
BOOL sol_found = FALSE;//used to report 1st total solution found
                       //Once found there are no thresholds on mem or cpu usage
BOOL current_phase_reported = FALSE;//Used by gen_gens
                       //should be in dumpfile but ignore this for time being
 
//**************************************************************************


void write_problem_params()
{
cout<<store_limit<<"["<<Array_bot<<".."<<Array_top<<"] ";
cout<<mem_penalty_bot<<" "<<F_tan_spread<<" "<<cpu_penalty_bot<<endl;
}

void missed(ptrmyfitnessvalue fitptr, int answer[NUM_TREES])
{//estimate number of time each tree would be run if stop_on error hadnt
 //prematurely aborted the tests. For Adfs etc this is pure guessing

ThisTest->not_run(fitptr, answer);

for(int t = NUM_OPERATIONS; t<NUM_TREES; t++) {
	const int mql = 3; //all a bit of a guess anyway

	answer[t] =   (t==Insert_adf)   ? answer[Insert]    * mql :
		      (t==Delete_adf)   ? answer[Delete]    * mql :
		      (t==Locate_adf)   ? answer[Locate]    * mql :
		      (t==Printlist_adf)? answer[Printlist] * mql :
			                  answer[Insert] + answer[Delete] + 
			                  answer[Locate] + answer[Printlist];
			      
}
}//end missed

BOOL Tree_OK(ptrmyfitnessvalue fitptr, int tree)
{
return	(tree==Insert_adf)   ? ThisTest->Operation_OK(fitptr,Insert)   :
	(tree==Delete_adf)   ? ThisTest->Operation_OK(fitptr,Delete)   :
	(tree==Locate_adf)   ? ThisTest->Operation_OK(fitptr,Locate)   :
	(tree==Printlist_adf)? ThisTest->Operation_OK(fitptr,Printlist):
		               ThisTest->Operation_OK(fitptr,tree);
}//end Tree_OK

// Define your FitnessValue class

void myfitnessvalue::write(ostream& fout)
{	{char buf[80]; sprintf(buf,"%4d",int(fvalue));
	 fout << buf;}
        scoretype total = 0;
	fout << " {";
	for (int i=first_op; i <= last_op; i++)
		{ total += hits[i];
		  char buf[80]; sprintf(buf,"%4.1f",hits[i]);
		  fout << buf << ",";
	        }
	fout << "[";
	for (i=0; i < NUM_OTHERS; i++)
		{ char buf[80]; sprintf(buf,"%4.1f",hits[i+last_op+1]);
		  fout << buf;
		  if (i < NUM_OTHERS-1 ) fout << ",";
	        }
	fout << "]}= " << total;
	fout << " mem " << int(mem_used)<<","<<Memory_errors();
#ifdef MINC_ADF
	fout << " adf1ver " << adf1;
#endif
#ifdef TIMINGS
	fout << " cpu " << cpu_time;
#endif
	fout << " tests " << Ntests_run;
#ifdef TRACE_RUN
	fout << " (";

	int notrun[NUM_TREES];
	missed(this, notrun);

	for (i=0; i < NUM_TREES; i++)
		{ char buf[80]; 
		  sprintf(buf,"%4d", ok(i)); fout << buf;
		  {if(Tree_OK(this,i))
			   fout<<"K"; else fout<<"-";}
		  sprintf(buf,"%-4d",nak(i)); fout << buf;
		  sprintf(buf,"%-4d",notrun[i]); fout << buf;		  
	        }
	fout << ")";
#endif
}//end myfitnessvalue::write

retval_cache   end_cache(1000);
retval_cache first_cache( 200);
retval_cache  next_cache(1000);
retval_cache  prev_cache( 200);

void cache_init()
{
	end_cache.init();
	first_cache.init();
	next_cache.init();
	prev_cache.init();
}

void cache_stats_init()
{
        end_cache.stats_init();
        first_cache.stats_init();
        next_cache.stats_init();
        prev_cache.stats_init();
}

void cache_stats()
{
	cout<<endl;
	cout<<"Size of end  cache " << end_cache.cache_used << endl;
	cout<<"Size of firstcache " << first_cache.cache_used << endl;
	cout<<"Size of next cache " << next_cache.cache_used << endl;
	cout<<"Size of prev cache " << prev_cache.cache_used << endl;
}

//**************************************************************************
///////////////////////// PROBLEM definition


OPDEF(RetrieveEval) {return calleval (tree_arg_num[Retrieve],Retrieve);}
OPDEF(EndEval)      {return calleval (tree_arg_num[End],     End,     FALSE,-1,
                                      &end_cache);}
OPDEF(FirstEval)    {return calleval (tree_arg_num[First],   First,   FALSE,-1,
                                      &first_cache);}
OPDEF(NextEval)     {return calleval (tree_arg_num[Next],    Next,    TRUE,-1,
                                      &next_cache);}
OPDEF(PrevEval)     {return calleval (tree_arg_num[Previous],Previous,TRUE,-1,
                                      &prev_cache);}
OPDEF(Adf1_InsertEval)     {return calleval (2, adf1,FALSE,Insert_adf);}
OPDEF(Adf1_DeleteEval)     {return calleval (2, adf1,FALSE,Delete_adf);}
OPDEF(Adf1_LocateEval)     {return calleval (2, adf1,FALSE,Locate_adf);}
OPDEF(Adf1_PrintlistEval)  {return calleval (2, adf1,FALSE,Printlist_adf);}
//OPDEF(Adf2Eval)            {return calleval (2, adf2);}
OPDEF(FUNCEval)            {return calleval (1, Arg2);}

int Adf1_Insert_funcnum = -1;
int Adf1_Delete_funcnum = -1;
int Adf1_Locate_funcnum = -1;
int Adf1_Printlist_funcnum = -1;

OPDEF(Insert_adfEval)    {return calleval (1,Insert_adf);}
OPDEF(Delete_adfEval)    {return calleval (1,Delete_adf);}
OPDEF(Locate_adfEval)    {return calleval (1,Locate_adf);}
OPDEF(Printlist_adfEval) {return calleval (1,Printlist_adf);}

gp::gp():i0_funcnum(0),
         for_funcnum(0),
	 down_funcnum(0),
	 while_funcnum(0),
	 forwhile_funcnum(0),
 
	 arg1_funcnum(0),
	 arg2_funcnum(0),
	 ARG1_funcnum(0),
	 ARG2_funcnum(0),
	 FUNC_funcnum(0),
 
	 print_funcnum(0)
{
//cout<<"gp::gp"<<endl;//debug
	ProbVersion = list_version;
	assert ( NUM_TREES >= NUM_OPERATIONS );

	AddF(new ConstFunc(0));    // REQUIRED as function 0

	// Add some standard primitives
	AddFall(new AddFunc(100));
	AddFall(new SubFunc(100));
        AddF3(Makenull,Insert,Delete,
	      new Function(2,0,100,Prog2Eval,"PROG2"));
//	AddF1(Locate_adf, new IflteFunc(100));
//	AddF1(Locate_adf, new Function(4,0,100,IfeqEval,"Ifeq"));

	AddFall(new Function(0,0,100,zeroEval,"0"));
	AddFall(new Function(0,0,100,oneEval,"1"));
	AddFall(new Function(0,0,100,MaxEval,"max"));
//	AddFall(new Function(0,0,100,BotEval,"bot"));
//	AddFall(new Function(0,0,100,TopEval,"top"));
	AddF5(Insert,Delete,End,First,adf1,
		new Function(0,0,100,Aux1Eval,"aux1"));
	AddF8(Retrieve,Next,Previous,adf1,
	      Insert_adf,Delete_adf,Locate_adf,Printlist_adf,
	      new Function(0,0,100,Arg1Eval,"arg1"));
        arg1_funcnum=funccount-1;
//        AddF1(adf2,new Function(0,0,100,Arg2Eval,"arg2"));
//        arg2_funcnum=funccount-1;
	AddF5(Insert,Locate,Delete,Delete_adf,Locate_adf,
	      new Function(0,0,100,ARG1Eval,"ARG1"));
        ARG1_funcnum=funccount-1;
        AddF1(Insert, new Function(0,0,100,ARG2Eval,"ARG2"));
        ARG2_funcnum=funccount-1;
//	AddF2(Insert,Delete,new Function(0,0,100,inc_Aux1Eval,"Inc_Aux1"));
//	AddF2(Insert,Delete,new Function(0,0,100,dec_Aux1Eval,"Dec_Aux1"));
	AddF3(Retrieve,Locate_adf,Printlist_adf,
	      new Function(1,0,100,readEval,"read"));
	AddF2(Makenull,Insert,
	      new Function(2,0,100,writeEval,"write"));
	AddF1(Makenull,new Function(1,0,100,set_Aux1Eval,"Set_Aux1"));

//	AddF4(Insert,Locate,Delete,Printlist,
//              new Function(3,0,100,ForEval,"for"));
//        for_funcnum=funccount-1;
//	AddF4(Insert,Locate,Delete,Printlist,
//              new Function(3,0,100,DownEval,"down"));
//        down_funcnum=funccount-1;
//	AddF4(Insert,Locate,Delete,Printlist,
//              new Function(2,0,100,WhileEval,"while"));
//        while_funcnum=funccount-1;
	AddF1(adf1,
              new Function(3,0,100,ForWhileEval,"forwhile"));
        forwhile_funcnum=funccount-1;
	AddF1(adf1,
              new Function(0,0,100,I0Eval,"i0"));
        i0_funcnum=funccount-1;
	AddF1(Printlist_adf,
              new Function(1,0,100,printEval,"print"));
        print_funcnum=funccount-1;
        AddF1(Insert,
	      new Function(1,0,100,Adf1_InsertEval,"adf1"));
        Adf1_Insert_funcnum=funccount-1;
        AddF1(Delete,
	      new Function(1,0,100,Adf1_DeleteEval,"adf1"));
        Adf1_Delete_funcnum=funccount-1;
        AddF1(Locate,
	      new Function(1,0,100,Adf1_LocateEval,"adf1"));
        Adf1_Locate_funcnum=funccount-1;
        AddF1(Printlist,
	      new Function(1,0,100,Adf1_PrintlistEval,"adf1"));
        Adf1_Printlist_funcnum=funccount-1;
        AddF2(Insert_adf,Delete_adf,
	      new Function(2,0,100,swapEval,"swap"));
//	      new Function(2,0,100,Adf2Eval,"adf2"));
        AddF1(adf1,
	      new Function(1,0,100,FUNCEval,"FUNC"));
        FUNC_funcnum=funccount-1;
//        AddF2(Locate,Printlist,
//	   new Function(tree_arg_num[Retrieve],0,100,RetrieveEval,"Retrieve"));
        AddF2(Makenull,adf1,
	    new Function(tree_arg_num[End],     0,100,EndEval,     "End"));
        AddF2(Locate,Printlist,
            new Function(tree_arg_num[First],   0,100,FirstEval,   "First"));
        AddF3(Insert,Delete,Delete_adf,
            new Function(tree_arg_num[Next],    0,100,NextEval,    "Next"));
        AddF1(Delete,
            new Function(tree_arg_num[Previous],0,100,PrevEval,    "Prev"));
}

void gp::LoadTests(istream& in)
{ 
test* t = new test (this, in);

t->write(this);
}

void gp::WriteTreeName(int tree, ostream& ostr)
{switch(tree)
	 {
	 case Makenull: ostr<< "makenul"; break;
	 case Retrieve: ostr<< "retriev"; break;
	 case Insert:   ostr<< "insert";  break;
	 case Delete:   ostr<< "delete";  break;
	 case End:      ostr<< "end";     break;
	 case First:    ostr<< "first";   break;
	 case Next:     ostr<< "next";    break;
	 case Previous: ostr<< "prev";    break;
	 case Locate:   ostr<< "locate";  break;
	 case Printlist:ostr<< "prtlist"; break;
	 case adf1:     ostr<< "adf1";    break;
//	 case adf2:     ostr<< "adf2";    break;
	 case Insert_adf:   ostr<< "ins_adf";  break;
	 case Delete_adf:   ostr<< "del_adf";  break;
	 case Locate_adf:   ostr<< "loc_adf";  break;
	 case Printlist_adf:ostr<< "prt_adf"; break;

	 default:       ostr<< "ERROR322"; break;
	 }
}//end queue::WriteTreeName()

BOOL gp::TreeNameMatch(int tree, char* s)
{switch(tree)
	 {
	 case Makenull: return strcmp("makenul", s);
	 case Retrieve: return strcmp("retriev", s);
	 case Insert:   return strcmp("insert",  s);
	 case Delete:   return strcmp("delete",  s);
	 case End:      return strcmp("end",     s);
	 case First:    return strcmp("first",   s);
	 case Next:     return strcmp("next",    s);
	 case Previous: return strcmp("prev",    s);
	 case Locate:   return strcmp("locate",  s);
	 case Printlist:return strcmp("prtlist", s);
	 case Insert_adf:    return strcmp("ins_adf", s);
	 case Delete_adf:    return strcmp("del_adf", s);
	 case Locate_adf:    return strcmp("loc_adf", s);
	 case Printlist_adf: return strcmp("prt_adf", s);

	 default:       return FALSE;
	 }
}//end queue::TreeNameMatch()

int static_check_loop_check = 0;
int gp::static_check(Chrome* chrome, int tree)
// Perform static analysis of new chromsome. Just changed in tree
{
//return 0; //Uncomment to disable static_check//ie ok
#ifdef DEBUG
if (tree==Insert  ||tree==Locate||tree==Delete  ||tree==Printlist||
    tree==Retrieve||tree==Next  ||tree==Previous||tree==adf1     ||
    tree==Insert_adf||tree==Delete_adf||tree==Locate_adf||tree==Printlist_adf){
chrome->write(PRETTY_NONE,cout,tree); cout<<endl;
}
#endif

int answer = 0; //ie ok

if (tree==adf1) {
	BOOL a = nested_tree_or_i0(chrome,tree);
	answer = a? 100 : 0;
#ifdef DEBUG
	cout<<" nested_tree_or_i0 = "<<(a? "TRUE" : "FALSE")<<endl;
#endif
	if (answer==0) {
		BOOL a = tree_contains(chrome,tree,i0_funcnum);
		answer = a? 0 : 100;
#ifdef DEBUG
		cout<<" tree_contains (i0) = "<<(a? "TRUE" : "FALSE")<<endl;
#endif
	}
}//check loop

if ((answer==0) && (tree==Retrieve  ||tree==Next      ||tree==Previous||
                    tree==adf1                        ||tree==Insert_adf ||
                    tree==Delete_adf||tree==Locate_adf||tree==Printlist_adf)) {
	BOOL a = tree_contains(chrome,tree,arg1_funcnum);
	answer = a? 0 : 100;
#ifdef DEBUG
	cout<<" tree_contains (arg1) = "<<(a? "TRUE" : "FALSE")<<endl;
#endif
}//check for arg1

//if ((answer==0) && (tree==Insert||tree==Locate||tree==Delete)) {
//	BOOL a = tree_contains(chrome,tree,ARG1_funcnum);
//	answer = a? 0 : 100;
//#ifdef DEBUG
//	cout<<" tree_contains (ARG1) = "<<(a? "TRUE" : "FALSE")<<endl;
//#endif
//}//check for ARG1

//if ((answer==0) && (tree==adf2)) {
//	BOOL a = tree_contains(chrome,tree,arg2_funcnum);
//	answer = a? 0 : 100;
//#ifdef DEBUG
//	cout<<" tree_contains (arg2) = "<<(a? "TRUE" : "FALSE")<<endl;
//#endif
//}//check for arg2

//if ((answer==0) && (tree==Insert)) {
//	BOOL a = tree_contains(chrome,tree,ARG2_funcnum);
//	answer = a? 0 : 100;
//#ifdef DEBUG
//	cout<<" tree_contains (ARG2) = "<<(a? "TRUE" : "FALSE")<<endl;
//#endif
//}//check for ARG2

if ((answer==0) && (tree==adf1)) {
	BOOL a = tree_contains(chrome,tree,FUNC_funcnum);
	answer = a? 0 : 100;
#ifdef DEBUG
	cout<<" tree_contains (FUNC) = "<<(a? "TRUE" : "FALSE")<<endl;
#endif
}//check for ARG2

if ((answer==0) && (tree==Printlist_adf)) {
	BOOL a = tree_contains(chrome,tree,print_funcnum);
	answer = a? 0 : 100;
#ifdef DEBUG
	cout<<" tree_contains (print) = "<<(a? "TRUE" : "FALSE")<<endl;
#endif
}//check for print

if(answer==0) {
	static_check_loop_check = 0;
	return 0; //says its ok
}
else {
	static_check_loop_check++;
//	if(static_check_loop_check>=10) {
	if(static_check_loop_check>=1000) {
		cout<<"static_check_looping on tree "<<tree;
		static_check_loop_check = 0;
		chrome->write(PRETTY_NONE,cout,tree); cout<<endl;
		return 0; //says its ok to abort overlong loop
	}
	else 
		return answer; 
}
}//end queue::static_check


void gp::write_stats(ostream& out)
{
        cout<<"End  "; end_cache.write();
        cout<<"First"; first_cache.write();
        cout<<"Next "; next_cache.write();
        cout<<"Prev "; prev_cache.write();

}

retval random_value(int& seed) //seed must be > 0
{
return retval(F_tan_spread*tan(float(intrnd(seed) % 3141)/1000.0));
}

void myfitnessvalue::clear()
{
//NB clearing whole of myfitnessclass cause gcc produced code to crash

//In theory dont need to do this most of the time since on copy or
//crossover will soon be overwritten with data from parent

//cout<<"Sizeof myfitnessvalue "<<sizeof(*this)<<endl;

memset(hits,0,sizeof(hits));
//memset(chain,0,sizeof(chain));
mem_used = 0;
#ifdef TRACE_RUN
#ifndef STORE_FIT
memset( ok,0,sizeof(ok));
memset(nak,0,sizeof(nak));
#endif
#endif
#ifdef STORE_FIT
memset(test_data,0,sizeof(test_data));
#endif
}

//inlined WBL 20-2-95
//void test::update_score(Chrome* chrome, int first_test, int last_test, 
//			scoretype score)
//{
//ptrmyfitnessvalue fitptr = ptrmyfitnessvalue (chrome->nfitness);
//
//for(int t = first_test; t<last_test; t++) {
//	if((tests[t].op<=last_op)&&(tests[t].op>=first_op)) {
//		fitptr->hits[tests[t].op] += score; }
//}
//}//end test::update_score

void test::update_passed(BOOL passed[], int first_test, int last_test) const
{
for(int t = first_test; t<last_test; t++) {
	passed[t] = TRUE; }
}//end test::update_passed


void test::set_max_fitness() const
{//we never stop
max_fitness = float (max_passes[num_phases-1])*(1.0+FLT_EPSILON); 

//check required for update_population_fitness(). Do it here because dont want
//it to abort the program run possibly after several hours or running

assert (num_ellite_pareto<=last_op+1); //since we dont change rank info
}

#ifdef STORE_FIT
void test::update_seq_score(Chrome* chrome, int s, //test_sequence
			    int seqpasses, int tests) const
{
const ptrmyfitnessvalue fitptr = ptrmyfitnessvalue (chrome->nfitness);

fitptr->test_data[s].mem_used = cells_written();
fitptr->test_data[s].memory_errors = (Memory_errors > 255)? 255: Memory_errors;

fitptr->test_data[s].Ntests_run = tests;

#ifdef TIMINGS
total_cpu += ThisTimmer->timmer(); //for statistical purposes only
fitptr->test_data[s].cpu_time =
	      (ThisTimmer->timmer() < myfitnessvalue::per_test::cpu_time_max)? 
	       ThisTimmer->timmer() : myfitnessvalue::per_test::cpu_time_max;
#endif
#ifdef TRACE_RUN
fitptr->test_data[s].trace.trace_pack(ThisTrace);
#endif

fitptr->test_data[s].passes = seqpasses;

}//end test::update_seq_score
#endif /*STORE_FIT*/

int myfitnessvalue::Memory_errors() const {
int count = 0;
for(int s=0; s<NUM_TEST_SEQUENCES;s++) {
	count += test_data[s].memory_errors;}
return count;
}

void update_population_fitness()
//now that a solution has been found new rules apply for fitness calculation
//scan whole of population and update each fitness value in line with new
//rules. Ie remove cpu and memory penalty thresholds
{
cout << "Removing memory and cpu penalty thresholds " << endl;

for(UINT j=0;j<ThisPop->popsize;j++) {
	const ptrmyfitnessvalue fitptr = 
		                 ptrmyfitnessvalue(ThisPop->pop[j]->nfitness);
	fitptr->hits[last_op+NUM_OTHERS] = -float(fitptr->mem_used);

#ifdef TIMINGS
	fitptr->hits[last_op+1         ] = -float(fitptr->cpu_time) / 
		                            float(fitptr->Ntests_run);
#endif
}//scan whole population
}//end update_population_fitness()

void reinitialise_population()
//At end of first test phase. Regenerate all delete/locate and their adfs
//This is required because initial population will have lost almost all
//it variation in these unused trees.
//Calculate the new fitness of the whole population
{
time_t t;
time (&t); cout << "Reinitialising population " << ctime(&t) << flush;

BOOL do_trees[NUM_TREES];
memset(do_trees,0,sizeof(do_trees));
do_trees[Delete]     = TRUE;
do_trees[Delete_adf] = TRUE;
do_trees[Locate]     = TRUE;
do_trees[Locate_adf] = TRUE;

ThisPop->reinitialise(do_trees);

time (&t); cout << "                     done " << ctime(&t) << endl;

}//end reinitialise_population()



int minmem_found; //lowest memory used by any solution so far
int minmerr_found;//lowest memory errors by any solution so far
int mincpu_found; //lowest cpu used by any solution reported so far


#ifdef STORE_FIT
float test::final_score(Chrome* chrome) const
#else
float test::final_score(Chrome* chrome, int passes, int tests) const
#endif
{
const ptrmyfitnessvalue fitptr = ptrmyfitnessvalue (chrome->nfitness);

#ifdef STORE_FIT
fitptr->mem_used = 0;
fitptr->Ntests_run = 0;
fitptr->cpu_time = 0;
int passes = 0;
//memset(fitptr->hits,0,sizeof(fitptr->hits));
//memset(fitptr->ok,  0,sizeof(fitptr->ok));
//memset(fitptr->nak, 0,sizeof(fitptr->nak));

ThisTest->unpack_hits(chrome);

for(int s=0; s<NUM_TEST_SEQUENCES;s++) {

if(fitptr->mem_used < fitptr->test_data[s].mem_used)
	fitptr->mem_used = fitptr->test_data[s].mem_used;

fitptr->Ntests_run += fitptr->test_data[s].Ntests_run;

#ifdef TIMINGS
fitptr->cpu_time += fitptr->test_data[s].cpu_time;
#endif
//#ifdef TRACE_RUN
//for(int t=0; t<NUM_TREES;t++) {
//	fitptr->ok[t]  += fitptr->test_data[s].trace.unpack_ok(t);  //add overflow
//	fitptr->nak[t] += fitptr->test_data[s].trace.unpack_nak(t); //checks!
//}
//#endif

passes += fitptr->test_data[s].passes;
}//endfor each test_sequence


#else /*STORE_FIT*/
int cw = cells_written();

if(fitptr->mem_used < cw)
	fitptr->mem_used = cw;

fitptr->Ntests_run = tests;

#ifdef TIMINGS
fitptr->cpu_time = ThisTimmer->timmer();
#endif /*TIMINGS*/

#endif /*STORE_FIT*/

tests_apparently_run += fitptr->Ntests_run;

chrome->nfitness->fvalue = float(passes);
BOOL display_solution = FALSE;

if(passes==max_passes[current_phase]) {
	num_sol_found++;
	if(num_sol_found==1) {
		display_solution = TRUE;
		minmem_found = fitptr->mem_used;
		minmerr_found = fitptr->Memory_errors();
		mincpu_found = fitptr->cpu_time;
	}
	else {
		if (fitptr->mem_used < minmem_found) {
			minmem_found = fitptr->mem_used;
			display_solution = TRUE; }

		int memerrs = fitptr->Memory_errors();
		if (memerrs < minmerr_found) {
			minmerr_found = memerrs;
			display_solution = TRUE; }
		
		if ((fitptr->cpu_time/1000) < (mincpu_found/1000)) {
			mincpu_found = fitptr->cpu_time;
			display_solution = TRUE; }
	}//endelse

	if(current_phase >= (NUM_TEST_PHASES-1) ) {
		sol_found = TRUE; 
                update_population_fitness(); //remove cpu and memory thresholds
	}

};//endif passes all tests ie a solution

fitptr->hits[last_op+NUM_OTHERS] = ((fitptr->mem_used <= mem_penalty_bot) &&
				    (!sol_found)                           ) ? 
				         0 : -fitptr->mem_used;
#ifdef TIMINGS
{
scoretype temp = float (fitptr->cpu_time)/ float(fitptr->Ntests_run);
fitptr->hits[last_op+1         ] = ((           temp <= cpu_penalty_bot)  &&
				    (!sol_found)                           ) ? 
					 0 : -temp;
}
#endif

//ptrmyfitnessvalue(chrome->nfitness)->update_rank(); now done in InsertMember cf ORIGINAL_RANK
if(display_solution && (ThisPop != NULL)) {
	cout << "\n\nafter " << ThisPop->gencount+1 << endl;
	fitptr->write();
	chrome->write(PRETTY_NONE,cout); cout<<endl;
}

return chrome->nfitness->fvalue;

}//end test::final_score


int end_gens()
{
	//Should we move on to next test phase?
	if((current_phase < (ThisTest->num_phases-1) ) && 
//FIX sometime. This changes functionality so wait until testing in /27*-jun-95
//has been completed
//            current_phase_reported                     &&
	   (num_sol_found >= 1000              )) { //allow solution to spread
		num_sol_found = 0;
		current_phase++;
		current_phase_reported = FALSE;
		reinitialise_population();
	}

	//Report 1st time we complete each test phase
	if( (num_sol_found > 0) && (!current_phase_reported) ) {
		current_phase_reported = TRUE;
		return current_phase + 1;
	}
	else
		return 0;
}//end_gens


BOOL IsLoop(int funcnum) {
return (funcnum==ThisProblem->forwhile_funcnum);
}

int IsBranch(int funcnum) {
return 0; //no branch instructions in list function set
}

int Chrome::ChooseCrossTree(Chrome* second_parent) {
//choose a promising tree to crossover between this and second_parent

//Select trees in this where there is a high ratio of possible failures to
//probable oks. Exclude cases where tree is never run or is always ok.

//ignores second_parent 

int tree = rnd(NUM_TREES);
int ok_trials = 0;
float best_ratio = -FLT_MAX;
const ptrmyfitnessvalue f1 = ptrmyfitnessvalue(this->nfitness);

int unknown[NUM_TREES];
missed(f1, unknown);

#ifdef DEBUG
int debug[100];
int d=0;
#endif

for(int trials = 0; (ok_trials<3) && (trials<100) && (best_ratio<FLT_MAX);
    trials++) {
	int t = rnd(NUM_TREES);
#ifdef DEBUG	
debug[d++] = t;
#endif
	if( !Tree_OK(f1,t) ) { //dont cross those that work
	const int f1_nak  = f1->nak(t);
	const int f1_ok   = f1->ok(t);
	if( (f1_ok != 0) ||    (f1_nak != 0)){//only change trees that are used
        if( (f1_nak!= 0) || (unknown[t]!= 0)){//only change when may hav failed
		const float ratio = 
		   ((f1_ok < f1_nak) ||
		    (f1_ok + unknown[t]) == 0)? FLT_MAX :
			   float(f1_nak+unknown[t])/float(f1_ok+unknown[t]);
		if( ratio > best_ratio ) {
			best_ratio = ratio;
			tree       = t;
		}
		ok_trials++;
	}
	}//endif tree used
	}//endif !Tree_OK
}//end for
#ifdef DEBUG
if(tree==Previous) {
	cout<<"ChoosePrevious ";
	for(int i = 0; i < d; i++) cout<<debug[i]<<" ";
	f1->write(cout);
	cout<<" "<<ThisPop->num_crosses[Previous]<<endl;
}
#endif
return tree;
} //end Chrome::ChooseCrossTree

#ifdef MAXTREEDEPTH
void gp::ProbLPStats(int f[][NUM_TREES][MAXTREEDEPTH+1], int pcount[pcount_size])
{
//      See if each tree that can use adf1 does so.
for ( int d = 0; d<=MAXTREEDEPTH; d++) {
pcount[0] += (( f[Adf1_Insert_funcnum][Insert][d] != 0 ) &&
	      ( f[Adf1_Delete_funcnum][Delete][d] != 0 ) &&
	      ( f[Adf1_Locate_funcnum][Locate][d] != 0 ) &&
	      ( f[Adf1_Printlist_funcnum][Printlist][d] != 0 )) ? 1: 0;

//      See if ARG1 is used by delete or its adf

pcount[1] += (( f[ARG1_funcnum][Delete][d]     != 0 ) ||
	      ( f[ARG1_funcnum][Delete_adf][d] != 0 ) ) ? 1: 0;

//      See if ARG1 is used by locate or its adf

pcount[2] += (( f[ARG1_funcnum][Locate][d]     != 0 ) ||
	      ( f[ARG1_funcnum][Locate_adf][d] != 0 ) ) ? 1: 0;

}//endfor all depths

pcount[3] += 1;//not used

}//end ProbLPStats
#else
void gp::ProbLPStats(int f[][NUM_TREES], int pcount[pcount_size] ) 
{
//      See if each tree that can use adf1 does so.

pcount[0] += (( f[Adf1_Insert_funcnum][Insert] != 0 ) &&
	      ( f[Adf1_Delete_funcnum][Delete] != 0 ) &&
	      ( f[Adf1_Locate_funcnum][Locate] != 0 ) &&
	      ( f[Adf1_Printlist_funcnum][Printlist] != 0 )) ? 1: 0;

//      See if ARG1 is used by delete or its adf

pcount[1] += (( f[ARG1_funcnum][Delete]     != 0 ) ||
	      ( f[ARG1_funcnum][Delete_adf] != 0 ) ) ? 1: 0;

//      See if ARG1 is used by locate or its adf

pcount[2] += (( f[ARG1_funcnum][Locate]     != 0 ) ||
	      ( f[ARG1_funcnum][Locate_adf] != 0 ) ) ? 1: 0;

pcount[3] += 1;//not used

}//end ProbLPStats
#endif /*MAXTREEDEPTH*/

int gp::ProbLTStat(int tree, int start, int length, node* expr )
{
//      Look for FUNC(I0) combinations

if(tree != adf1) return -1; //ignore

for(int ip=start; ip < (start+length); ) {
	if(expr[ip++].op==FUNC_funcnum){
		int args = 1;
		while (args > 0)
			{
				if(expr[ip].op==i0_funcnum) return 1;

				args=args+ARGNUM()-1;
				ip++;
			}
	}

}

return 0;

}//end ProbLTStat
